library ieee;
use ieee.std_logic_1164.all;

entity dec2x4 is
  port(clk: in std_logic;
       we: in std_logic_vector(1 downto 0);
       wlacz: in std_logic;
       wy0, wy1, wy2, wy3: out std_logic);
end dec2x4;

architecture dec2x4_arch of dec2x4 is
  signal qw: std_logic_vector(3 downto 0) := "0000";
begin
  process(clk, wlacz)
  begin
    if rising_edge(clk) then
      qw <= "0000";
      if wlacz = '1' then
        if we = "00" then 
          qw(0) <= '1';
        end if;
        if we = "01" then 
          qw(1) <= '1';
        end if;
        if we = "10" then 
          qw(2) <= '1';
        end if;
        if we = "11" then 
          qw(3) <= '1';
        end if;
      end if;
    end if;
  end process;
  wy0 <= qw(0);
  wy1 <= qw(1);
  wy2 <= qw(2);
  wy3 <= qw(3);
end dec2x4_arch;

